/* begincopyright
  Copyright (c) 1988 Xerox Corporation. All rights reserved.
  Use and copying of this software and preparation of derivative works based
  upon this software are permitted. Any distribution of this software or
  derivative works must comply with all applicable United States export
  control laws. This software is made available AS IS, and Xerox Corporation
  makes no warranty about the software, its performance or its conformity to
  any specification. Any person obtaining a copy of this software is requested
  to send their name and post office or electronic mail address to:
    PCR Coordinator
    Xerox PARC
    3333 Coyote Hill Rd.
    Palo Alto, CA 94304
  endcopyright */

/*
 * CirioNubTypes.h
 *
 * Demers, February 25, 1992 1:46:08 pm PST
 *
 * CirioNub types.
 */

#ifndef _CIRIO_NUB_TYPES_
#define _CIRIO_NUB_TYPES_

#ifndef _XR_BASIC_TYPES_
#   include "xr/BasicTypes.h"
#endif

#ifndef _XR_THREADS_
#   include "xr/Threads.h"
#endif

#include <sys/types.h>

/*
 * Thread descriptor
 */

typedef struct CirioNubThreadDataRep {
    unsigned cntd_index;
    unsigned cntd_gen;
    XR_SStat cntd_sStat;
    XR_Pri cntd_pri;
    XR_DBMsg cntd_dbMsg;
    bool cntd_dbFrozen;
    XR_Pointer cntd_pc;
    XR_Pointer cntd_sp;
    XR_Pointer cntd_fp;
} * CirioNubThreadData;

/*
 * Procedure info
 */

typedef struct CirioNubPCInfoRep {
    char *procName;
    unsigned procSymID;
    char *fileName;
    unsigned fileSeqNum;
    char *guessedEmbeddedFileName;
    unsigned guessedEmbeddedFileSymID;
} *CirioNubPCInfo;

/*
 * File description
 */

typedef struct CirioNubFileEntryRep {
    unsigned seqNum;
    bool commitPoint;
    char *fileName;
    unsigned fOffset;
    unsigned fMagic;
    size_t size;
    time_t mTime;
    unsigned sMagic;
    XR_Pointer stamp;
    unsigned stampSize;
    XR_Pointer readerData;
    unsigned readerDataSize;
    XR_Pointer patchReloc;
    unsigned patchSize;
    XR_Pointer textReloc;
    unsigned textSize;
    XR_Pointer dataReloc;
    unsigned dataSize;
    XR_Pointer bssReloc;
    unsigned bssSize;
    XR_Pointer commonReloc;
    unsigned commonSize;
} * CirioNubFileEntry;


/*
 * Symbol table entry
 */

typedef struct CirioNubSymEntryRep {
    unsigned symID;
    char *name;
    unsigned type;
    unsigned value;
    unsigned size;
    unsigned fileSeqNum;
} *CirioNubSymEntry;


/*
 * Instruction Set + Operating System names
 */

typedef struct CirioNubInstrSetAndOpSysRep {
    char *instrSet;
    char *opSys;
} *CirioNubInstrSetAndOpSys;


#endif /* _CIRIO_NUB_TYPES_ */
